'' Full Screen Editor
'' By Jeff Ledger


CON
  '' I/O SETTINGS
  
  '' Adjust for typical location of the keyboard. Usually 26 on the demoboard
  
   keyboard  = 12 '26
   video     = 24 '12
   
 '' Basic Color Settings

  BLACK             = $02 
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3 
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03 
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1 
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

 '' ==== NO CHANGES REQUIRED PAST THIS POINT ====



   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000

  '' Key Assignments 

   fReturn   = 13
   bspKey    = $C8
   escape    = $CB
   backspace = 8

  CR                            = $0D
  LF                            = $0A
  TAB                           = $09
  BKS                           = $08



   
OBJ
     key   : "comboKeyboard"             ' Keyboard Driver
     text  : "aigeneric_driver"
      
VAR
     byte screen[1004] ' try not to use ODD sizes for buffers, can catch you out in the long run.
     long oldchr
     
PUB mainProgram  | size, r,sta,bytes

  key.start(keyboard)
  text.start(video)
 
  waitcnt(clkfreq + cnt)
  if not key.present                                
     text.str(string(13,"No keyboard present",CR))
     text.str(string("Keyboard expected on: "))
     text.dec(keyboard)
     text.str(string(13,CR,"System halted.",CR))
     abort
 

  repeat
   input(@screen,1000)

 
       
PUB input(data, size) | keystroke,len,row,col,z,textcolor
   keystroke:=0
   len:=0
   row:=0
   col:=0
   textcolor:=white

   repeat

     oldchr:=text.GetChar(row,col) 'jb mod
     text.PokeChar(row,col,textcolor,$02)
     keystroke := key.getkey
     text.PutChar(row,col,oldchr)

'' CHECK FOR COLOR CHANGES

     if keystroke == 561  'Control+1
       textcolor:=lred
       keystroke :=0

     if keystroke == 562   'Control+2
       textcolor:=white
       keystroke :=0

     if keystroke == 563   'Control+3
      textcolor:=skyblue
      keystroke :=0

     if keystroke == 564   'Control+4
      textcolor:=purple
      keystroke :=0

'' CHECK CURSOR MOVEMENTS
      
     if keystroke == 13 and row < 24 ' ENTER
       row++
       col:=0
       keystroke := 0

     if keystroke == 13
       keystroke :=0
      
     if keystroke == 195 and row < 24  'Cursor Down
       row++
       keystroke :=0

     if keystroke == 195
       keystroke :=0
      
     if keystroke == 194 and row > 0  'Cursor Up
       row--
       keystroke :=0

     if keystroke == 194
       keystroke :=0
      
     if keystroke == 192  'Cursor Left
       col--
       keystroke :=0

     if keystroke == $C8  'Backspace
       col--
       text.PokeChar(row,col,textcolor," ")
       keystroke :=0

     if keystroke == 193  'Cursor Right
       col++
       keystroke := 0

     if keystroke == 196 'HOME
       col:=0
       keystroke :=0

     if keystroke == 197 'END
       col:=39
       keystroke :=0       
       
     if keystroke == 203 ' check screen ESC
      text.cls
      row:=0
      col:=0
      keystroke:=0

      
     if col == 40
       col:=0
       row++
       
     if keystroke > 0  
      'text.dec(keystroke)   
      text.PokeChar(row,col,textcolor,keystroke)
      col++
     


